searchNodes=[{"ref":"EventBus.Postgres.html","title":"EventBus.Postgres","module":"EventBus.Postgres","type":"module","doc":"Postgres plugin for EventBus"},{"ref":"EventBus.Postgres.html#process/1","title":"EventBus.Postgres.process/1","module":"EventBus.Postgres","type":"function","doc":"Deliver EventBus events to Postgres queue"},{"ref":"EventBus.Postgres.Bucket.html","title":"EventBus.Postgres.Bucket","module":"EventBus.Postgres.Bucket","type":"module","doc":"Event persistence worker"},{"ref":"EventBus.Postgres.Bucket.html#init/1","title":"EventBus.Postgres.Bucket.init/1","module":"EventBus.Postgres.Bucket","type":"function","doc":"Invoked when the server is started. start_link/3 (or start/3) will block until this callback returns. args is the argument term (second argument) passed to start_link/3 (or start/3). In case of successful start, this callback must return a tuple where the first element is the stage type, which is one of: :producer :consumer :producer_consumer (if the stage is acting as both) For example: def init(args) do {:producer, some_state} end The returned tuple may also contain 3 or 4 elements. The third element may be the :hibernate atom or a set of options defined below. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling terminate/2. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling terminate/2. Options This callback may return options. Some options are specific to the chosen stage type while others are shared across all types. :producer options :demand - when :forward, the demand is always forwarded to the c:handle_demand/2 callback. When :accumulate, demand is accumulated until its mode is set to :forward via demand/2. This is useful as a synchronization mechanism, where the demand is accumulated until all consumers are subscribed. Defaults to :forward. :producer and :producer_consumer options :buffer_size - the size of the buffer to store events without demand. Can be :infinity to signal no limit on the buffer size. Check the &quot;Buffer events&quot; section of the module documentation. Defaults to 10_000 for :producer, :infinity for :producer_consumer. :buffer_keep - returns whether the :first or :last entries should be kept on the buffer in case the buffer size is exceeded. Defaults to :last. :dispatcher - the dispatcher responsible for handling demands. Defaults to GenStage.DemandDispatch. May be either an atom representing a dispatcher module or a two-element tuple with the dispatcher module and the dispatcher options. :consumer and :producer_consumer options :subscribe_to - a list of producers to subscribe to. Each element represents either the producer module or a tuple with the producer module and the subscription options (as defined in sync_subscribe/2). Callback implementation for GenStage.init/1."},{"ref":"EventBus.Postgres.Bucket.html#start_link/0","title":"EventBus.Postgres.Bucket.start_link/0","module":"EventBus.Postgres.Bucket","type":"function","doc":""},{"ref":"EventBus.Postgres.Config.html","title":"EventBus.Postgres.Config","module":"EventBus.Postgres.Config","type":"module","doc":"Config reader"},{"ref":"EventBus.Postgres.Config.html#auto_delete_with_ttl?/0","title":"EventBus.Postgres.Config.auto_delete_with_ttl?/0","module":"EventBus.Postgres.Config","type":"function","doc":""},{"ref":"EventBus.Postgres.Config.html#buffer_size/0","title":"EventBus.Postgres.Config.buffer_size/0","module":"EventBus.Postgres.Config","type":"function","doc":""},{"ref":"EventBus.Postgres.Config.html#db_pool_size/0","title":"EventBus.Postgres.Config.db_pool_size/0","module":"EventBus.Postgres.Config","type":"function","doc":""},{"ref":"EventBus.Postgres.Config.html#db_url/0","title":"EventBus.Postgres.Config.db_url/0","module":"EventBus.Postgres.Config","type":"function","doc":""},{"ref":"EventBus.Postgres.Config.html#default_ttl/0","title":"EventBus.Postgres.Config.default_ttl/0","module":"EventBus.Postgres.Config","type":"function","doc":""},{"ref":"EventBus.Postgres.Config.html#deletion_period/0","title":"EventBus.Postgres.Config.deletion_period/0","module":"EventBus.Postgres.Config","type":"function","doc":""},{"ref":"EventBus.Postgres.Config.html#enabled?/0","title":"EventBus.Postgres.Config.enabled?/0","module":"EventBus.Postgres.Config","type":"function","doc":""},{"ref":"EventBus.Postgres.Config.html#max_demand/0","title":"EventBus.Postgres.Config.max_demand/0","module":"EventBus.Postgres.Config","type":"function","doc":""},{"ref":"EventBus.Postgres.Config.html#min_demand/0","title":"EventBus.Postgres.Config.min_demand/0","module":"EventBus.Postgres.Config","type":"function","doc":""},{"ref":"EventBus.Postgres.Config.html#pool_size/0","title":"EventBus.Postgres.Config.pool_size/0","module":"EventBus.Postgres.Config","type":"function","doc":""},{"ref":"EventBus.Postgres.Config.html#topics/0","title":"EventBus.Postgres.Config.topics/0","module":"EventBus.Postgres.Config","type":"function","doc":""},{"ref":"EventBus.Postgres.EventMapper.html","title":"EventBus.Postgres.EventMapper","module":"EventBus.Postgres.EventMapper","type":"module","doc":"Mapper for EventBus events to Postgres scheme"},{"ref":"EventBus.Postgres.EventMapper.html#handle_demand/2","title":"EventBus.Postgres.EventMapper.handle_demand/2","module":"EventBus.Postgres.EventMapper","type":"function","doc":"Invoked on :producer stages. This callback is invoked on :producer stages with the demand from consumers/dispatcher. The producer that implements this callback must either store the demand, or return the amount of requested events. Must always be explicitly implemented by :producer stages. Examples def handle_demand(demand, state) do # We check if we&#39;re able to satisfy the demand and fetch # events if we aren&#39;t. events = if length(state.events) &gt;= demand do state.events else # fetch_events() end # We dispatch only the requested number of events. {to_dispatch, remaining} = Enum.split(events, demand) {:noreply, to_dispatch, %{state | events: remaining}} end Callback implementation for GenStage.handle_demand/2."},{"ref":"EventBus.Postgres.EventMapper.html#handle_events/3","title":"EventBus.Postgres.EventMapper.handle_events/3","module":"EventBus.Postgres.EventMapper","type":"function","doc":"Invoked on :producer_consumer and :consumer stages to handle events. Must always be explicitly implemented by such types. Return values are the same as c:handle_cast/2. Callback implementation for GenStage.handle_events/3."},{"ref":"EventBus.Postgres.EventMapper.html#init/1","title":"EventBus.Postgres.EventMapper.init/1","module":"EventBus.Postgres.EventMapper","type":"function","doc":"Invoked when the server is started. start_link/3 (or start/3) will block until this callback returns. args is the argument term (second argument) passed to start_link/3 (or start/3). In case of successful start, this callback must return a tuple where the first element is the stage type, which is one of: :producer :consumer :producer_consumer (if the stage is acting as both) For example: def init(args) do {:producer, some_state} end The returned tuple may also contain 3 or 4 elements. The third element may be the :hibernate atom or a set of options defined below. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling terminate/2. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling terminate/2. Options This callback may return options. Some options are specific to the chosen stage type while others are shared across all types. :producer options :demand - when :forward, the demand is always forwarded to the c:handle_demand/2 callback. When :accumulate, demand is accumulated until its mode is set to :forward via demand/2. This is useful as a synchronization mechanism, where the demand is accumulated until all consumers are subscribed. Defaults to :forward. :producer and :producer_consumer options :buffer_size - the size of the buffer to store events without demand. Can be :infinity to signal no limit on the buffer size. Check the &quot;Buffer events&quot; section of the module documentation. Defaults to 10_000 for :producer, :infinity for :producer_consumer. :buffer_keep - returns whether the :first or :last entries should be kept on the buffer in case the buffer size is exceeded. Defaults to :last. :dispatcher - the dispatcher responsible for handling demands. Defaults to GenStage.DemandDispatch. May be either an atom representing a dispatcher module or a two-element tuple with the dispatcher module and the dispatcher options. :consumer and :producer_consumer options :subscribe_to - a list of producers to subscribe to. Each element represents either the producer module or a tuple with the producer module and the subscription options (as defined in sync_subscribe/2). Callback implementation for GenStage.init/1."},{"ref":"EventBus.Postgres.EventMapper.html#start_link/1","title":"EventBus.Postgres.EventMapper.start_link/1","module":"EventBus.Postgres.EventMapper","type":"function","doc":""},{"ref":"EventBus.Postgres.Model.Event.html","title":"EventBus.Postgres.Model.Event","module":"EventBus.Postgres.Model.Event","type":"module","doc":"Event model/struct"},{"ref":"EventBus.Postgres.Queue.html","title":"EventBus.Postgres.Queue","module":"EventBus.Postgres.Queue","type":"module","doc":"Postgres queue (producer)"},{"ref":"EventBus.Postgres.Queue.html#init/1","title":"EventBus.Postgres.Queue.init/1","module":"EventBus.Postgres.Queue","type":"function","doc":"Invoked when the server is started. start_link/3 (or start/3) will block until this callback returns. args is the argument term (second argument) passed to start_link/3 (or start/3). In case of successful start, this callback must return a tuple where the first element is the stage type, which is one of: :producer :consumer :producer_consumer (if the stage is acting as both) For example: def init(args) do {:producer, some_state} end The returned tuple may also contain 3 or 4 elements. The third element may be the :hibernate atom or a set of options defined below. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling terminate/2. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling terminate/2. Options This callback may return options. Some options are specific to the chosen stage type while others are shared across all types. :producer options :demand - when :forward, the demand is always forwarded to the c:handle_demand/2 callback. When :accumulate, demand is accumulated until its mode is set to :forward via demand/2. This is useful as a synchronization mechanism, where the demand is accumulated until all consumers are subscribed. Defaults to :forward. :producer and :producer_consumer options :buffer_size - the size of the buffer to store events without demand. Can be :infinity to signal no limit on the buffer size. Check the &quot;Buffer events&quot; section of the module documentation. Defaults to 10_000 for :producer, :infinity for :producer_consumer. :buffer_keep - returns whether the :first or :last entries should be kept on the buffer in case the buffer size is exceeded. Defaults to :last. :dispatcher - the dispatcher responsible for handling demands. Defaults to GenStage.DemandDispatch. May be either an atom representing a dispatcher module or a two-element tuple with the dispatcher module and the dispatcher options. :consumer and :producer_consumer options :subscribe_to - a list of producers to subscribe to. Each element represents either the producer module or a tuple with the producer module and the subscription options (as defined in sync_subscribe/2). Callback implementation for GenStage.init/1."},{"ref":"EventBus.Postgres.Queue.html#push/1","title":"EventBus.Postgres.Queue.push/1","module":"EventBus.Postgres.Queue","type":"function","doc":"Push event shadows to queue"},{"ref":"EventBus.Postgres.Queue.html#start_link/1","title":"EventBus.Postgres.Queue.start_link/1","module":"EventBus.Postgres.Queue","type":"function","doc":""},{"ref":"EventBus.Postgres.Store.html","title":"EventBus.Postgres.Store","module":"EventBus.Postgres.Store","type":"module","doc":"Basic db actions"},{"ref":"EventBus.Postgres.Store.html#all/1","title":"EventBus.Postgres.Store.all/1","module":"EventBus.Postgres.Store","type":"function","doc":"Fetch all events with pagination"},{"ref":"EventBus.Postgres.Store.html#batch_insert/1","title":"EventBus.Postgres.Store.batch_insert/1","module":"EventBus.Postgres.Store","type":"function","doc":"Batch insert"},{"ref":"EventBus.Postgres.Store.html#count/1","title":"EventBus.Postgres.Store.count/1","module":"EventBus.Postgres.Store","type":"function","doc":"Total events since given time"},{"ref":"EventBus.Postgres.Store.html#count_per_topic/1","title":"EventBus.Postgres.Store.count_per_topic/1","module":"EventBus.Postgres.Store","type":"function","doc":"Total events per topic since given time"},{"ref":"EventBus.Postgres.Store.html#delete/1","title":"EventBus.Postgres.Store.delete/1","module":"EventBus.Postgres.Store","type":"function","doc":"Delete an event"},{"ref":"EventBus.Postgres.Store.html#delete_expired/0","title":"EventBus.Postgres.Store.delete_expired/0","module":"EventBus.Postgres.Store","type":"function","doc":"Delete expired events"},{"ref":"EventBus.Postgres.Store.html#find/1","title":"EventBus.Postgres.Store.find/1","module":"EventBus.Postgres.Store","type":"function","doc":"Find an event"},{"ref":"EventBus.Postgres.Store.html#find_all_by_transaction_id/1","title":"EventBus.Postgres.Store.find_all_by_transaction_id/1","module":"EventBus.Postgres.Store","type":"function","doc":"Fetch all events with pagination"}]